import geomerative.*;        // Libraries importieren
import processing.serial.*;

RShape grp;                  // Hierdrin ist die Vektorgrafik gespeichert. Rshape ist der Variablentyp/Klasse
RPoint[][] pointPaths;       // Darin werden die einzelnen Punkte gespeichert.                              

boolean ignoringStyles = false;             //aus GetPointPaths übernommen

float faktor;         //speichert Wert, mit dem die Punkte multipliziert werden müssen, damit Bild auf unser Koordinatensystem angepasst ist
String xstring = "x";
String ystring = "y";
String senden;       //speichert den zu sendenden String



void setup(){
  lauf = 0;
  RG.init(this);                            //aus GetPointPaths übernommen
  RG.ignoreStyles(ignoringStyles);          //aus GetPointPaths übernommen
  
  RG.setPolygonizer(RG.ADAPTATIVE);        // bestimmt, dass der Winkel zwischen 3 aufeinander folgenden Punkten nicht zu spitz wird
  
  grp = RG.loadShape("circle.svg");        // lädt Datei (data Ordner, muss im gleichen Verzeichnis wie diese Datei liegen!)
  grp.centerIn(g, 100, 1, 1);              // zentriert Grafik
  
  pointPaths = grp.getPointsInPaths();     // wandelt Vektorgrafik aus grp in einzelne Punkte um und speichert diese in pointPaths  
 
  String portName = Serial.list()[Serial.list().length-1];
  int baudrate = 115200;   //Baudrate zwischen Processing und Arduino (muss bei beiden gleich sein!)
  myPort = new Serial(this, portName, baudrate);
  
  float rand;
   //betrachtet, welches die jeweils äußersten Punkte für Höhe und Breite sind und speichert jeweils den Abstand zwischen diesen Punkten:
  float breite = grp.getBoundsPoints()[1].x - grp.getBoundsPoints()[0].x;
  float hoehe  = grp.getBoundsPoints()[2].y - grp.getBoundsPoints()[1].y;
  if (breite < hoehe) {
    rand = hoehe;
  }
  else {
    rand = breite;
  }
 
  faktor = 30/rand; //Faktor wird durch unsere Bildbreite/-höhe (30) durch die längere Seite berechnet, damit das Bild skaliert werden kann
}

Serial myPort;
int lauf=0;
void draw()
{

  if(lauf == 0)
  {
    for(int i = 0; i<pointPaths.length; i++) // geht Anzahl der in der Vektorgrafik existierenden Linien durch
    {         
      if (pointPaths[i] != null) // falls die Linie Punkte enthält
      {
        float x = pointPaths[i][0].x;   //nächste x-Koordinate aus der Liste wird gespeichert
        float y = pointPaths[i][0].y;   //nächste y-Koordinate aus der Liste wird gespeichert
        
        // Anpassung vom eigentlichen Bild an unser Koordinatensystem:
        x *= faktor;                                  
        y *= faktor;
        
        delay(10);
      
        for(int j = 0; j<pointPaths[i].length; j++)// gehe alle Punkte in der Linie durch       ---j=1
        {
          x = pointPaths[i][j].x; //nächste x-Koordinate aus der Liste wird gespeichert
          y = pointPaths[i][j].y; //nächste y-Koordinate aus der Liste wird gespeichert
          x *= faktor;
          y *= faktor;
         
          while(myPort.read()!='0')  //wartet, bis Arduino bereit ist, Daten zu empfangen
          {
            delay(10);      
          }
          
          println("Sende Daten");
          myPort.write(xstring+str(x)+ystring+str(y)+'\n'); //der zu sendende String wird im entsprechenden Format erstellt und an den Arduino gesendet
          senden = xstring+str(x)+ystring+str(y)+'\n';  
          println(senden);
          delay(10);
        }
      myPort.write('e');  
    }      
   }
  }
  lauf++;
}